#include "r_smc_entry.h"
#include "tbrx140def.h"

#define KNL_LEVEL 6
uint8_t NORTi_INT_HOOK_KNL_LEVEL = KNL_LEVEL;

void NORTi_INT_HOOK_init(void);
void v3_ent_int(void);
void v3_ret_int (void);

#pragma inline_asm v3_ent_int
void v3_ent_int(void)
{
    MVTIPL #KNL_LEVEL
    SETPSW I
}

#pragma inline_asm v3_ret_int
void v3_ret_int (void)
{
    RTE
}

#define VECT_TRAP_1 1
#define VECT_TRAP_2 2

void main(void);

void main(void)
{
    NORTi_INT_HOOK_init();

    R_BSP_SET_IPL( KNL_LEVEL - 1 );
    R_BSP_INT( VECT( TRAP, 1 ) );
    R_BSP_INT( VECT( TRAP, 2 ) );

    R_BSP_SET_IPL( KNL_LEVEL );
    //R_BSP_INT( VECT( TRAP, 1 ) );
    R_BSP_INT( VECT( TRAP, 2 ) );

    R_BSP_SET_IPL( KNL_LEVEL + 1 );
    //R_BSP_INT( VECT( TRAP, 1 ) );
    R_BSP_INT( VECT( TRAP, 2 ) );

    R_BSP_NOP();

    for(;;);

#if 0
    LED0 = LED_OFF;
    LED1 = LED_OFF;

    if (SW1_PUSH == SW1) /*SW1_PUSH = Manual Mode,  Other = Auto Mode*/
    {
        R_Config_ICU_IRQ0_Start();
    }
    else
    {
        R_Config_CMT0_Start();
    }
    while(1)
    {
        ; /* Blink LED0, LED1 Alternately by Interrupt */
    }
#endif
}

uint32_t debug = 0x5a5a5a5a;

#pragma interrupt trap1_isr(vect = VECT(TRAP, 1))
static void trap1_isr(void)
{
    debug = 1;
}

#pragma interrupt trap2_isr(vect = VECT(TRAP, 2))
static void trap2_isr(void)
{
    debug = 2;
}
